C $Header: /u/u0/gcmpack/MITgcm/pkg/aim/AIM_DIAGS.h,v 1.3 2001/03/06 17:50:32 jmc Exp $
C $Name:  $

#ifdef COMPONENT_MODULE

C     /==========================================================\
C     | CPL_DIAGS.h                                              |
C     | o Header for CPL diagnostic output                       |
C     |==========================================================|
C     | Declares global arrays used for holding/accumulating     |
C     | diagnostic output from CPL.                              |
C     \==========================================================/

#ifdef ALLOW_TIMEAVE

C     Timer for CPL diags
      _RL CPL_TimeAve(Nr,nSx,nSy)
      COMMON /CPL_TAVE/ CPL_TimeAve

C     HFtave  - Net heat-flux (w/m^2, +ve into atmos.)
C     TXtave  - zonal momentum
C     TYtave  - meridional momentum
C     FWtave  - fresh water (g/(m^2 s)
C     UGtave  - u @ ground
C     VGtave  - v @ ground
C     QLTtave  - latent heat flux (W/m2)
C     QSNtave  - sensible heat flux (W/m2)
C     QLNtave  - longwave heat flux (W/m2)
C     QSHtave  - shortwave heat flux (W/m2)
C     QSHtave  - shortwave heat flux (W/m2)
C     SSTtave  - ocean temperature.
C
      COMMON /CPL_TAVE/
     &                   HFtave, TXtave, TYtave, FWtave,
     &                   UGtave, VGtave,
     &                   QLTtave, QSNtave, QLNtave, QSHtave,
     &                   SSTtave
      _RL  HFtave  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  TXtave  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  TYtave  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  FWtave  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  UGtave  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  VGtave  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  QLTtave (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  QSNtave (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  QLNtave (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  QSHtave (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  SSTtave (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#endif /* ALLOW_TIMEAVE */


#endif /* COMPONENT_MODULE */

